import spss, spssaux
from extension import Template, Syntax, processcmd

def Run(args):

    args = args[args.keys()[0]]

    oobj = Syntax([
      Template("VARIABLES",subc="",ktype="existingvarlist",var="vars",islist=True),
      Template("MAXCOR",subc="OPTIONS",ktype="float",var="maxcor")])

    processcmd(oobj, args, rpolychor, vardict=spssaux.VariableDict())

def rpolychor(vars, maxcor=0.9999):
    
        varX = vars[0]
        varY = vars[1]
        pgm = r"""BEGIN PROGRAM R.
library(polycor)
data <- spssdata.GetDataFromSPSS(variables=c("%(varX)s","%(varY)s"),missingValueToNA=TRUE)
result <- polychor(data[["%(varX)s"]],data[["%(varY)s"]],maxcor=%(maxcor)s)

# Create output to display the result in the Viewer
spsspkg.StartProcedure("Polychoric Correlation")
spsspivottable.Display(result,title="Correlation",
                       rowlabels=c("%(varX)s"),
                       collabels=c("%(varY)s"),
                       format=formatSpec.Correlation)
spsspkg.EndProcedure()
END PROGRAM.
""" % locals()

        spss.Submit(pgm)
